/**
 * @module @adonisjs/http-server
 */
/// <reference path="../../adonis-typings/index.d.ts" />
/// <reference types="node" />
import { Macroable } from 'macroable';
import { RouteNode } from '@ioc:Adonis/Core/Route';
import { IncomingMessage, ServerResponse } from 'http';
import { LoggerContract } from '@ioc:Adonis/Core/Logger';
import { RequestContract } from '@ioc:Adonis/Core/Request';
import { ResponseContract } from '@ioc:Adonis/Core/Response';
import { ServerConfigContract } from '@ioc:Adonis/Core/Server';
import { ProfilerRowContract } from '@ioc:Adonis/Core/Profiler';
import { EncryptionContract } from '@ioc:Adonis/Core/Encryption';
import { HttpContextContract } from '@ioc:Adonis/Core/HttpContext';
/**
 * Http context is passed to all route handlers, middleware,
 * error handler and server hooks.
 */
export declare class HttpContext extends Macroable implements HttpContextContract {
    request: RequestContract;
    response: ResponseContract;
    logger: LoggerContract;
    profiler: ProfilerRowContract;
    params: any;
    subdomains: any;
    route?: RouteNode;
    /**
     * Required by macroable
     */
    protected static macros: {};
    protected static getters: {};
    constructor(request: RequestContract, response: ResponseContract, logger: LoggerContract, profiler: ProfilerRowContract);
    /**
     * A helper to see top level properties on the context object
     */
    inspect(): string;
    /**
     * Creates a new fake context instance for a given route.
     */
    static create(routePattern: string, routeParams: any, logger: LoggerContract, profiler: ProfilerRowContract, encryption: EncryptionContract, req?: IncomingMessage, res?: ServerResponse, serverConfig?: ServerConfigContract): HttpContext;
}
